CON                              
                                 
  _clkmode = xtal1 + pll16x      
  _xinfreq = 5_000_000

{{V3 removes redundant commands   }}           

OBJ                                        

  Menu  : "Menu"   
  eeprom  : "Propeller Eeprom"  

VAR
    byte Y[5], cog   
    long stack[5]  '[20]  Doesn't require big stack yet

PUB main     
  
  Menu.Init    
  Add_value

PUB Init : success

  Stop
  success := (cog := cognew(Add_value, @stack)) + 1
PUB Stop

  if cog
    cogstop (cog~ - 1)  
  
PUB Add_value
  'Displays values in "Y" array
   Load
   repeat      
     Menu.DisplayElement(Y[0], 0)     'need index
     Menu.DisplayElement(Y[1], 1)
     Menu.DisplayElement(Y[2], 2)
     Menu.DisplayElement(Y[3], 3)
     Menu.DisplayElement(Y[4], 4)
     Menu.GetElement(0)           ' Wait for user input  
     Save_It(7)                    'Random value for testing purposes 

PUB Save_It(x) : idx            'Thanks to kuroneko for writing the repeat loop!   
   
  repeat                        ' scan for free slot          
    ifnot Y[idx]                ' use local idx         
      Y[idx] := x               ' found free (==0) quit loop
      Backup_element(idx)
      quit                      ' update global index and store value
    idx++                                                           
    if idx > 4                  ' If array full,
      bytefill(@Y[0], 0, 5)     ' reset, array and idx  (start addr, value, count)
      Y[0] := x 
      Backup_array              ' These two lines don't seem affected by switching order                                                                               
                                                                                          
PUB Backup_element(idx)

    eeprom.VarBackup(@Y[idx], @Y[idx])      '+ $8000

PUB Backup_array                                 '' Back up entire array to EEPROM
                                                 
   eeprom.VarBackup(@Y, @Y[4])       ' Copy Y array from RAM to EEPROM

PUB Load                                         '' Load entire array from EEPROM
                                                 
  eeprom.VarRestore(@Y, @Y[4])      ' Copy array from EEPROM to RAM      